<template>
  <b-container
    fluid
    class="mt-5 justify-content-md-center text-center"
  >
    <h1 class="text-center pb-4">GitLab Onboarding Buddy Generator</h1>

    <b-row class="justify-content-md-center text-center pb-4">
      <b-col cols="4" >
        <b-form @submit="onSubmit">
          <!-- <b-form-group
            id="input-group-1"
            label="My new team member is from the following department"
            label-for="department"
            description="We will make sure not to select someone from the same department"
          >
            <b-form-select
              id="division"
              v-model="form.division"
              :options="options"
            />
          </b-form-group> -->

          <b-button
            type="submit"
            variant="primary"
          >Generate Buddy</b-button>
        </b-form>
      </b-col>
    </b-row>

    <b-row v-if="memberId !== null">
      <b-col>
        <span>{{ teamData[memberId].name }}</span>
        <span
          v-if="teamData[memberId].gitlab"
          class="d-block"
        >
          <a href="https://gitlab.com/teamData[memberId].gitlab">
            @{{ teamData[memberId].gitlab }}
          </a>
        </span>
        <span
          class="d-block"
          v-html="teamData[memberId].role" />
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import jsyaml from 'js-yaml'
import axios from 'axios'

export default {
  async asyncData({ params }) {
    let { data } = await axios.get(
      `${'https://cors-anywhere.herokuapp.com/'}https://gitlab.com/gitlab-com/www-gitlab-com/raw/master/data/team.yml`,
      { crossdomain: true }
    )
    return { teamData: jsyaml.load(data) }
  },
  data() {
    return {
      memberId: null
    }
  },
  computed: {
    invalidBuddy() {
      let { name } = this.teamData[this.memberId]
      name = name.toLowerCase()

      return (
        name.includes('new vacancy') ||
        name.includes('interim') ||
        name === 'you?' ||
        // If a name is an initial, that means they haven't
        // started yet. Hence not a valid potential buddy
        name.match(/[a-z][.][a-z][.]/g)
      )
    }
  },
  methods: {
    generateBuddy() {
      this.memberId = Math.floor(
        Math.random() * Math.floor(this.teamData.length)
      )
    },
    onSubmit(e) {
      e.preventDefault()

      this.generateBuddy()

      while (this.invalidBuddy) {
        this.generateBuddy()
      }
    }
  }
}
</script>
